#include "cui.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MSG(s) fprintf(stderr, "%s() %s L%d : %s\n", __func__, __FILE__, __LINE__, s)
#define ERR(s) do{ fprintf(stderr, "ERR "); MSG(s); exit(1); }while(0)

cui
cui_alloc(int size)
{
	cui obj;

	if((obj = malloc(size)) == NULL) ERR("No Mem");
	return obj;
}

void
cui_base_init(cui obj, cui parent, int x, int y, int w, int h)
{
	obj->parent = parent;
	obj->children = NULL;
	obj->next = NULL;
	obj->x = x;
	obj->y = y;
	obj->w = w;
	obj->h = h;

	if(parent) cui_base_child_add(parent, obj);
}

void
cui_base_child_add(cui obj, cui child)
{
	child->next = obj->children;
	obj->children = child;
}

cui
cui_panel_new(cui parent, int x, int y, int w, int h)
{
	cui obj = cui_alloc(sizeof(struct cui_panel));
	cui_panel_init(obj, parent, x, y, w, h);
	return obj;
}

void
cui_panel_init(cui obj, cui parent, int x, int y, int w, int h)
{
	cui_base_init(obj, parent, x, y, w, h);
}

cui
cui_label_new(cui parent, int x, int y, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_label));
	cui_label_init(obj, parent, x, y, s);
	return obj;
}

void
cui_label_init(cui obj, cui parent, int x, int y, char *s)
{
	cui_label p = (cui_label)obj;
	cui_base_init(obj, parent, x, y, strlen(s), 1);
	p->s = s;	
}

cui
cui_button_new(cui parent, int x, int y, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_button));
	cui_button_init(obj, parent, x, y, s);
	return obj;
}

void
cui_button_init(cui obj, cui parent, int x, int y, char *s)
{
	cui_label_init(obj, parent, x, y, s);
	obj->w += 2;
}

/* EOF */
